"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSelectMessage = exports.isPatternMessage = exports.isMessage = exports.isCatchallKey = void 0;
/**
 * A type guard for {@link CatchallKey} values
 *
 * @beta
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const isCatchallKey = (key) => !!key && typeof key === 'object' && key.type === '*';
exports.isCatchallKey = isCatchallKey;
/**
 * A type guard for {@link Message} values
 *
 * @beta
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const isMessage = (msg) => !!msg &&
    typeof msg === 'object' &&
    (msg.type === 'message' ||
        msg.type === 'select' ||
        (msg.type === 'junk' && msg.declarations));
exports.isMessage = isMessage;
/**
 * A type guard for {@link PatternMessage} values
 *
 * @beta
 */
const isPatternMessage = (msg) => msg.type === 'message';
exports.isPatternMessage = isPatternMessage;
/**
 * A type guard for {@link SelectMessage} values
 *
 * @beta
 */
const isSelectMessage = (msg) => msg.type === 'select';
exports.isSelectMessage = isSelectMessage;
