/**
 * The minimum amount of information required to determine the locale to use
 * when formatting a MessageValue.
 *
 * @beta
 */
export interface LocaleContext {
    localeMatcher: 'best fit' | 'lookup' | undefined;
    locales: string[];
}
/**
 * When constructing a {@link LocaleContext},
 * {@link MessageValue} or one of its child classes,
 * the locale information may be given in a number of different shapes.
 *
 * @beta
 */
export type LocaleContextArg = string | readonly string[] | Readonly<LocaleContext> | null;
/**
 * Type guard for {@link LocaleContext}
 *
 * @beta
 */
export declare const isLocaleContext: (lc: LocaleContextArg) => lc is Readonly<LocaleContext>;
/**
 * Create a new LocaleContext, using `orig` as a base.
 *
 * @beta
 * @returns `null` if both arguments are `null`
 */
export declare function extendLocaleContext(orig: Readonly<LocaleContext> | null, lc: LocaleContextArg): LocaleContext | null;
