import { Context } from '../format-context';
import { LocaleContextArg } from './locale-context';
import { MessageValue, Meta } from './message-value';
/**
 * A child class of {@link MessageValue} for Date values.
 *
 * @beta
 */
export declare class MessageDateTime extends MessageValue<Date> {
    options?: Intl.DateTimeFormatOptions;
    constructor(locale: LocaleContextArg, date: number | Date | Readonly<MessageDateTime>, { meta, options, source }?: {
        meta?: Readonly<Meta>;
        options?: Readonly<Intl.DateTimeFormatOptions>;
        source?: string;
    });
    private getDateTimeFormatter;
    toParts(): Intl.DateTimeFormatPart[];
    toString(onError?: Context['onError']): string;
}
