import { Context } from '../format-context';
import type { LocaleContextArg } from './locale-context';
import { MessageValue, Meta } from './message-value';
/**
 * A child class of {@link MessageValue} for starting markup elements.
 *
 * @beta
 */
export declare class MessageMarkupStart extends MessageValue<string> {
    options: Record<string, unknown>;
    constructor(locale: LocaleContextArg, name: string, { meta, options, source }: {
        meta?: Readonly<Meta>;
        options?: Readonly<Record<string, unknown>>;
        source?: string;
    });
    matchSelectKey(): boolean;
    toString(onError?: Context['onError']): string;
}
/**
 * A child class of {@link MessageValue} for ending markup elements.
 *
 * @beta
 */
export declare class MessageMarkupEnd extends MessageValue<string> {
    constructor(locale: LocaleContextArg, name: string, options: {
        meta?: Readonly<Meta>;
        source?: string;
    });
    matchSelectKey(): boolean;
    toString(): string;
}
