"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _MessageValue_localeContext;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageValue = exports.hasMeta = exports.FALLBACK_SOURCE = void 0;
const locale_context_1 = require("./locale-context");
exports.FALLBACK_SOURCE = '???';
/**
 * Type guard for message values that may contain a `meta` member
 *
 * @beta
 */
const hasMeta = (part) => !!part.meta &&
    typeof part.meta === 'object' &&
    Object.keys(part.meta).length > 0;
exports.hasMeta = hasMeta;
/**
 * The base class of all message values.
 *
 * @beta
 */
class MessageValue {
    constructor(type, locale, value, format) {
        _MessageValue_localeContext.set(this, void 0);
        this.type = type ?? 'value';
        this.value = value;
        __classPrivateFieldSet(this, _MessageValue_localeContext, locale, "f");
        if (format) {
            const { meta, source, toString } = format;
            if (source)
                this.source = source;
            if (meta)
                this.meta = { ...meta };
            if (toString && Object.prototype.hasOwnProperty.call(format, 'toString'))
                this.toString = toString;
        }
    }
    get localeContext() {
        let localeMatcher;
        let locales;
        const lc = __classPrivateFieldGet(this, _MessageValue_localeContext, "f");
        if (lc && typeof lc === 'string')
            locales = [lc];
        else if (Array.isArray(lc))
            locales = lc.slice();
        else if ((0, locale_context_1.isLocaleContext)(lc)) {
            locales = lc.locales.slice();
            localeMatcher = lc.localeMatcher;
        }
        return locales ? { locales, localeMatcher } : null;
    }
    set localeContext(locale) {
        __classPrivateFieldSet(this, _MessageValue_localeContext, locale, "f");
    }
    matchSelectKey(key) {
        return this.value != null && String(this.value) === key;
    }
    toString(onError) {
        const value = this.value;
        try {
            const lc = this.localeContext;
            if (lc && value && typeof value.toLocaleString === 'function') {
                const lm = lc.localeMatcher;
                const opt = lm ? { localeMatcher: lm } : undefined;
                return value.toLocaleString(lc.locales, opt);
            }
        }
        catch (error) {
            if (onError)
                onError(error, this);
            if (value === undefined) {
                const source = this.source || exports.FALLBACK_SOURCE;
                return `{${source}}`;
            }
        }
        return String(value);
    }
}
exports.MessageValue = MessageValue;
_MessageValue_localeContext = new WeakMap();
