import { RuntimeOptions } from './index';
/**
 * Utility function for custom functions.
 * Cast resolved option values `'true'` and `'false'` to their Boolean equivalents.
 * Any other values are untouched.
 *
 * @param options Options object, which may be modified.
 * @param names Names of options that should have boolean values.
 */
export declare function castAsBoolean(options: RuntimeOptions, ...names: string[]): void;
/**
 * Utility function for custom functions.
 * Cast resolved option values with numerical string representations of integers
 * to their Number equivalents. Any other values are untouched.
 *
 * @param options Options object, which may be modified.
 * @param names Names of options that should have integer values.
 */
export declare function castAsInteger(options: RuntimeOptions, ...names: string[]): void;
