"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.number = exports.datetime = void 0;
const message_value_1 = require("../message-value");
const cast_1 = require("./cast");
function datetime(locales, options, arg) {
    let date;
    if (!arg)
        date = new Date();
    else if (arg instanceof message_value_1.MessageDateTime)
        date = arg;
    else if (typeof arg.value === 'number')
        date = new Date(arg.value);
    else
        date = new Date(String(arg.value));
    (0, cast_1.castAsBoolean)(options, 'hour12');
    (0, cast_1.castAsInteger)(options, 'fractionalSecondDigits');
    return new message_value_1.MessageDateTime(locales, date, { options });
}
exports.datetime = datetime;
Object.freeze(datetime);
function number(locales, options, arg) {
    const num = arg instanceof message_value_1.MessageNumber ? arg : Number(arg?.value);
    (0, cast_1.castAsBoolean)(options, 'useGrouping');
    (0, cast_1.castAsInteger)(options, 'minimumIntegerDigits', 'minimumFractionDigits', 'maximumFractionDigits', 'minimumSignificantDigits', 'maximumSignificantDigits');
    return new message_value_1.MessageNumber(locales, num, { options });
}
exports.number = number;
Object.freeze(number);
