"use strict";
/* eslint-disable @typescript-eslint/no-explicit-any */
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultRuntime = exports.castAsInteger = exports.castAsBoolean = void 0;
const default_1 = require("./default");
var cast_1 = require("./cast");
Object.defineProperty(exports, "castAsBoolean", { enumerable: true, get: function () { return cast_1.castAsBoolean; } });
Object.defineProperty(exports, "castAsInteger", { enumerable: true, get: function () { return cast_1.castAsInteger; } });
/**
 * The default Runtime includes two functions, `datetime` and `number`.
 *
 * @remarks
 * - `datetime` accepts an optional Date, number or string as its argument
 *   and formats it with the same options as
 *   {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/DateTimeFormat | Intl.DateTimeFormat}.
 *   If not given any argument, the current date/time is used.
 * - `number` accepts a number, BigInt or string representing a number as its argument
 *   and formats it with the same options as
 *   {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/NumberFormat | Intl.NumberFormat}.
 *   It also supports plural category selection via
 *   {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/PluralRules | Intl.PluralRules}
 *
 * @beta
 */
exports.defaultRuntime = { datetime: default_1.datetime, number: default_1.number };
